/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.aufgabe.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class AufgabeTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.Long nummer;
    public java.lang.Long getNummer(){
      return nummer;
    }

  public AufgabeTK(
java.lang.Long nummer
  ) {
    super();


      this.nummer = nummer;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((nummer == null) ? 0 : nummer.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof AufgabeTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        AufgabeTK other = (AufgabeTK) obj;

                if (nummer == null) {
          if (other.nummer != null) {
            return false;
          }
        } else if (!nummer.equals(other.nummer)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return AufgabeConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(AufgabeConstants.MESSAGE_KEY_ENTITY_EINZAHL, AufgabeConstants.MESSAGE_KEY_NUMMER_EINZAHL, nummer));
        
        return result;
      }


            @Override
            public String toString() {
            return "AufgabeTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"nummer="+nummer
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(AufgabeConstants.MESSAGE_KEY_NUMMER_EINZAHL) + "=" +

                                    nummer
                
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Aufgabe> java.util.Map<AufgabeTK, E> mappeAufgabeNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Aufgabe::getAufgabeTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Aufgabe, AufgabeTK> getAufgabeToTKFunction() {
                return Aufgabe::getAufgabeTK;
                }

}
